<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaGfipmagnet extends \Doctrine\ORM\EntityRepository {
    
    public function retornaRegistros($mesCompetencia, $nrOrg, $cdoperador) {
        
        $FpaGfipmagnet = Repositories::FPA_GFIPMAGNET;
        
        $sql = <<<SQL
SELECT gf
  FROM $FpaGfipmagnet gf
WHERE   gf.nrorg = :nrorg AND
        gf.mescompetencia = :mescompetencia AND 
        gf.nrorginclusao = :nrorginclusao AND 
        gf.cdoperinclusao = :cdoperinclusao  
			ORDER BY gf.idtpinscestrutu, gf.cdinscestrut, gf.idtpinscesttoma, gf.cdinscestrutoma, gf.nrpispaseppes, gf.dtadmissaovinc, gf.idtiporegistro
SQL;
        $params = array(
            'nrorg' => $nrOrg,
            'mescompetencia' => $mesCompetencia,
            'nrorginclusao' => $nrOrg,
            'cdoperinclusao' => $cdoperador
        );
        
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaRegistrosPorTipo($mesCompetencia, $listaTipoRegistro, $nrOrg, $cdoperador){
         
        $FpaGfipmagnet = Repositories::FPA_GFIPMAGNET;
        
        $sql = <<<SQL
SELECT gf
  FROM $FpaGfipmagnet gf
WHERE   gf.nrorg = :nrorg AND
        gf.idtiporegistro IN ($listaTipoRegistro) AND 
        gf.mescompetencia = :mescompetencia AND 
        gf.nrorginclusao = :nrorginclusao AND 
        gf.cdoperinclusao = :cdoperinclusao  
			
SQL;
        $params = array(
            'nrorg' => $nrOrg,
            'mescompetencia' => $mesCompetencia,
            'nrorginclusao' => $nrOrg,
            'cdoperinclusao' => $cdoperador
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaRegistrosTrabalhador(
        $mesCompetencia, $nrOrg, $tipoRegistro, $tipoInscricao, $nrInscricao, $tipoInscricaoTom, $nrInscricaoTom, $nrPisPasepCi,
        $dataAdmissao, $categoriaTrabalhador, $cdOperador
    ){
        $FpaGfipmagnet = Repositories::FPA_GFIPMAGNET;
        
        $sql = <<<SQL
SELECT gf
  FROM $FpaGfipmagnet gf
WHERE   
        gf.mescompetencia = :mescompetencia AND
        gf.nrorg = :nrorg AND
        gf.idtiporegistro = :idtiporegistro AND
        gf.idtpinscestrutu = :idtpinscestrutu AND
        gf.cdinscestrut = :cdinscestrut AND
        (gf.idtpinscesttoma = :idtpinscesttoma OR :idtpinscesttoma IS NULL) AND
        (gf.cdinscestrutoma = :cdinscestrutoma OR :cdinscestrutoma IS NULL) AND
        (gf.nrpispaseppes = :nrpispaseppes OR :nrpispaseppes IS NULL) AND
        gf.dtadmissaovinc = :dtadmissaovinc AND
        gf.idcategtrab = :idcategtrab AND
        gf.nrorginclusao = :nrorginclusao AND
        gf.cdoperinclusao = :cdoperinclusao 
			
SQL;
        $params = array(
            'mescompetencia' => $mesCompetencia,
            'nrorg' => $nrOrg,
            'idtiporegistro' => $tipoRegistro,
            'idtpinscestrutu' => $tipoInscricao,
            'cdinscestrut' => $nrInscricao,
            'idtpinscesttoma' => $tipoInscricaoTom,
            'cdinscestrutoma' => $nrInscricaoTom,
            'nrpispaseppes' => $nrPisPasepCi,
            'dtadmissaovinc' => $dataAdmissao,
            'idcategtrab' => $categoriaTrabalhador,
            'nrorginclusao' => $nrOrg,
            'cdoperinclusao' => $cdOperador
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        if(is_array($result)){
            return $result[0];
        }
        return $result;
    }
    
}